#pragma vertex
#pragma include "zframework/modules/render/shaders/glsl/libs/Default.vert.glsl"

void main()
{
    defaultMain();
}

#pragma fragment
#pragma include "zframework/modules/render/shaders/glsl/libs/Default.frag.glsl"

uniform float u_reverseScale;
uniform float u_rotationAngle;
uniform vec4 u_customColor;

// TODO: move these functions to ZF3?

vec2 rotateUV(vec2 uv, float rotation, vec2 mid)
{
    float cosValue = cos(rotation);
    float sinValue = sin(rotation);

    return vec2(
        cosValue * (uv.x - mid.x) + sinValue * (uv.y - mid.y) + mid.x,
        cosValue * (uv.y - mid.y) - sinValue * (uv.x - mid.x) + mid.y
    );
}

vec2 rotateUV(vec2 uv, float rotation, float mid)
{
    return rotateUV(uv, rotation, vec2(mid, mid));
}

vec2 rotateUV(vec2 uv, float rotation)
{
    return rotateUV(uv, rotation, vec2(0.5, 0.5));
}

void main()
{
    vec2 uv = rotateUV(v_uv * u_reverseScale, u_rotationAngle);
    gl_FragColor = u_customColor * getColor(uv);
    alphaTest();
}
